import java.lang.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.http.*;



//This is the Class which is used for Entering and modifing the Schema of a Course
//When ever the Faculty opted for entering the Schema.After checking whether 
//The faculty is actually taking the Course. A object of this called is Created 
//And the Function Process_Schema is called.The function prints the page
//For entering the details of the maxmarks and the weigtage of the quizzes.
//And after the schema is submiited the fuction process_mark_schema is called
//Which creates the tables the m_semno_course and w_semno_course
//which store the marks and the schema.






public class FacSchema {
	String login;
	String marks_table;
	String weight_table;
	int number_exams;
	String cname;
	String snum;
	
	Connection con;
	public FacSchema(String login_id,Connection conn){
					login = new String(login_id);
					con=conn;
	}


//The fuction reads the course name and the semester number then checks 
//in the course_details_semnum whether the faculty is taking the course
//If yes then print the form which has the fields for entering the
//Max marks and the Weightage of the Quizzes.

	public void process_schema(HttpServletRequest req,Statement stat,PrintWriter out)
		throws SQLException {
		HttpSession hs=req.getSession(true);	
		cname = hs.getValue("course").toString();
		snum =hs.getValue("sem").toString();
		String number = (String) req.getParameter("number");
		if(cname.equals("") || snum.equals("")|| number.equals(""))
		{
			out.println("<html> All the fields are not filled</html>");
			return;
		}
//check if the faculty is taking the course or not.
		String gen="select fno from course_details_"+snum+
							" where  cno='" +cname+"'";
		
		ResultSet rs = stat.executeQuery(gen);
		number_exams = Integer.parseInt(number);
//If yes then go through the method else prompt to the professor
		if(rs.next()){
		  	String check= rs.getString("fno");
			if(check.equals(login)){
				weight_table ="W_";
				marks_table ="M_";
//The string weight_table and marks_table for the sqlqueries.
				weight_table= weight_table.concat(snum+"_" + cname);
				marks_table= marks_table.concat(snum+"_" + cname);
				
				ResultSet Rs = stat.executeQuery("select table_name from tabs where table_name='"+weight_table.toUpperCase()+"'");
				if(!(Rs.next()))
				{

//Genrating the html form dynamically it reads the number_exams and prints 
//that many option for the quizzes.
					int j;
					out.println("<html>");
					out.println("<h1>For entering the max marks for the quizzes </h1>");
					out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024/servlet/UdayServlet\" method=\"post\">");
					out.println("<input type=\"hidden\" name=\"formnum\" value=\"1012\">");
					out.println("<table border=3>");
					for(j=0;j<number_exams; j++){
						out.println("<td>Weightage of quiz "+(j+1)+ "<input type=\"text\"  name=\"weight"+(j+1)+"\"" +"></td>");
						out.println("<td>Max. marks obtainable in quiz "+(j+1)+ "<input type=\"text\" name=\"max"+(j+1)+"\"" +"></td>");
						out.println("<td>Select the flag <select name=\"flag"+(j+1)+"\" >"+
							" <option selected value=\"2\">protected <option value=\"1\">private <option value=\"3\">public</select></td><tr>");
					}
					out.println("<td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>"+
					"<td><input  type=\"reset\" name=\"reset\" value=\"reset\"></td>");
					out.println("</form></table></body></html>");
				}
				else
					out.println("A schema already exists. In case you want to "+
					"change the schema please use modify option");
			}			
			else
				out.println("The faculty is not taking this course");
		}
		else
			out.println("The course does not exists");
				
	}

//The fuction is called when the professor submits by filling the form genreated
// by the above function filling the maxmarks and weightage of the quizzes
//It reads the values in the arrays and then checks if all the filled 
//If not then prompt the same and checks if the weightage amounts to 100
//It creates the Schema table and the marks table which is used to store the
//Marks of the quizzes.


	public void process_mark_schema(HttpServletRequest req,Statement stat , PrintWriter out)
		throws SQLException{
		int j;
		float total;
		int maxmark[]=new int[number_exams];
		float w[] = new float[number_exams];
		int flag[]= new int[number_exams];
		try{
			for(j=0;j<number_exams;j++){
				String tmp = (String)req.getParameter("weight"+(j+1));
				Float temp = new  Float(tmp);
				w[j] = temp.floatValue();
				String tmp1 = (String)req.getParameter("max"+(j+1));
				maxmark[j] = Integer.parseInt(tmp1);
				String tmp2=(String)req.getParameter("flag"+(j+1));
				flag[j]=Integer.parseInt(tmp2);
				if(tmp.equals("") || temp.equals("")){
							out.println("All fields are not filled");
							return;
				}

			}
			total=0;
			for(j=0;j<number_exams;j++)
					total+=w[j];
			if(!(total==100))
			{

		//The total does not sum up to 100 so ths schema is not valid BUH
				out.println("The total Weight does not sum up to 100");
				return;
			}

		//This creates the schema table for this purticular course
		//The two table the weight_table which has the schema the weightage of the
		//quizzes maxmarks and the flag for the viewing the marks of all the quizzes
			String crt = "create table " + weight_table + " " +
							"(quizno number(2),maxmarks number(3) , weight number(5,2) ,flag number(1))";
			stat.executeUpdate(crt);
			String tmp;
			for(j=0;j<number_exams;j++)
			{
					tmp = "insert into " + weight_table +" values ( " + (j+1) +" , " + maxmark[j]+" , " +w[j] +", " +flag[j]+") ";
					stat.executeUpdate(tmp);
			 }


		 //Now create the marks_table which has the fields the roll number and 
	 //and the marks for the number of quizzes given in the schema.
			String str2="create table " + marks_table + " ( srollno varchar(10)  ";
			for(j=0; j<number_exams; j++)
					str2 = str2.concat(" , quiz_" + (j+1) + " number(4,2) ");
			str2 = str2.concat(" , constraint "+ marks_table + " foreign key (srollno) references student " +
									" on delete cascade) ");
			
			stat.executeUpdate(str2);
			stat.executeUpdate("update course_details_"+snum+"  set number_exams= "+ number_exams +
													"where cno='" + cname+"'");
			out.println("<html><body>");
			out.println("The schema of the Course is Created<br>");
			out.println("Quiznum   Maxmarks     weight<br>");
			for(j=0;j<number_exams;j++)
					out.println("<pre>        "+(j+1)+"           "+ maxmark[j] + "          "+ w[j]+"  </pre><br>");
				out.println("</body></html>");
		}catch(SQLException e){out.println(e);}
	}
}
