
import java.util.*;
import java.util.Date;
import java.io.*;
import java.sql.*;
import java.lang.*;
import javax.servlet.http.*;
import java.util.Date;

public class FacultySession extends GrSession{
	String login;
	FacSchema schema;
	ModifySchema schema1;
	ChangePerms perm;
	ProfView viewmarks;
	

//Constructor For The Faculty Session it call the Constructor of the
//Session and then Stores the String login So as to Use the login afterwards 
//for later authorization of the faculty when entering the marks etc.

	public FacultySession(Connection con,String a){
			super(con);
			login = new String(a);
	}


//The Following Function is used to print the HTML files it takes the file name
// and prints the file to the printWriter.

	public void printpage(PrintWriter out,String filename)
		throws FileNotFoundException,IOException{
		
		FileInputStream infile = new FileInputStream(filename);
		InputStreamReader reader = new InputStreamReader (infile);
		BufferedReader input = new BufferedReader (reader);
		String temp;
		
		while ( (temp = input.readLine())!=null)
					out.println(temp);
	}

//This is the Main Fuction in the StudentSession(Session) when ever 
// The student presses a submit button This fuction is called from the 
//doPost fuction in the main UdayServlet.It reads the Hidden Field
//In the Form and then Calls the Appropriate Function.

	public void processQuery( HttpServletRequest req,PrintWriter out)
		throws IOException,SQLException{
		String formnumber = (String)req.getParameter("formnum");
		Integer temp = new Integer(formnumber);
		Statement stat1 = con.createStatement();
		HttpSession hs1=req.getSession(true);
		String cour=(String)hs1.getValue("course");
		String semes=(String)hs1.getValue("sem");
		switch(temp.intValue())
		{
		case 0:
			String login_id = hs1.getValue("login_id").toString();
	/*change*/	Statement query = con.createStatement();
				Date date = new Date();
			int year = date.getYear()+1900;
			ResultSet rs = query.executeQuery("select cno from course where fno='"+login_id+"'");
			printpage(out,"/users/ug97/bhati/Proj/html/faculty.html");
			out.println("<td><select name=cnum>");
				while(rs.next()){
					String cr=rs.getString("cno");
					out.println("<option value\""+cr+"\">"+cr);
				}
				out.println("</select></td>");
				out.println("<tr><td>Enter the semester no.</td> ");
				out.println("<td><select name=semno>");
				out.println("<option value\"spr\">spr<option value\"aut\">aut");
				out.println("</select>");
				out.println("</td><td><input type=\"text\" name=\"year1\" value=\""+year+"\"></td>");
				printpage(out,"/users/ug97/bhati/Proj/html/faculty1.html");
			break;
		case 10:
			String course=new String(req.getParameter("cnum"));
			String semester=req.getParameter("semno");
			String year11=req.getParameter("year1");
				String sem=new String(semester+year11);
				HttpSession hs=req.getSession(true);
				hs.putValue("course",course);
				hs.putValue("sem",sem);
				out.println("<html>course number selected is :"+course.toString()+"<br>");
				out.println("semester number selected is :"+sem.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/Faculty.html");
				break;
			case 1:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/Schemaqueries.html");
				break;
			case 2:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/MarksQueries.html");
				break;
			case 3:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/Gradequeries.html");
				break;
			case 101:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/Schema.html");
				break;
			case 1011:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				schema=new FacSchema(login,con);
				schema.process_schema(req,stat1,out);
				break;
			case 1012:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				schema.process_mark_schema(req,stat1,out);
				break;
			case 102:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/ModifySchema.html");
				break;
			 case 1021:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				schema1 = new ModifySchema(login,con);
				schema1.Modify_schema(req,stat1,out);
				break;
			case 1022:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				schema1.Modify_enter(req,stat1,out);
				break;
		//change new case 1023
			case 1023:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				schema1=new ModifySchema(login,con);
				schema1.add_a_quiz(req,stat1,out);
				break;
			case 103:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/ViewSchema.html");
				break;
			case 1031:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				process_view_schema(req,out);
				break;
/*			case 104:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				query = con.createStatement();
				Date date = new Date();
				int year = date.getYear()+1900;
				ResultSet rs = query.executeQuery("select cno from course where fno='"+login+"'");
				printpage(out,"/users/ug97/bhati/Proj/html/changeperms.html");
				out.println("<select name=course>");
				while(rs.next()){
					String cr=rs.getString("cno");
					out.println("<option value\""+cr+"\">"+cr);
				}
				out.println("</select>");
				out.println("<br>Enter the semester no. ");
				out.println("<select name=sem>");
				out.println("<option value\"spr\">spr<option value\"aut\">aut");
				out.println("</select>");
				out.println("<td><input type=\"text\" name=\"year1\" value=\""+year+"\"></td><br>");
				printpage(out,"/users/ug97/bhati/Proj/html/changeperms1.html");
				break;*/
			case 1041:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				perm = new ChangePerms(login,con);
				perm.Change_perms(req,out);
				break;
			case 1042:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				perm.changes_save(req,out);
				break;
			case 201:				
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/entermoption.html");
				break;
			case 2011:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				process_stum(req, stat1, out);
				break;
			case 20111:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/stum.html");
				break;	
			case 20112:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/read_file.html");
				break ;
			case 2012:	
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				process_enter_marks(req,stat1,out);
				break;
			case 202:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/vstum.html");
				break;
			case 2021:						
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				viewmarks = new ProfView(login,con);
				viewmarks.process_viewm(req,stat1,out);
				break;
			case 20211:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				viewmarks.process_sortform(req,out);
				break;
			case 20212:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				viewmarks.process_range(req, out);
				break;
			case 20213:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				viewmarks.process_distribution(req, out);
				break;
			case 20214:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				viewmarks.process_fsort(req,out);
				break;
			case 20215:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				viewmarks.process_frange(req,out);
				break;
			case 20216:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				hs = req.getSession(true);
				String str_brk_pts = new String(req.getParameter("part"));
				hs.putValue("str_brk_pts",str_brk_pts);
				viewmarks.process_fdistribution(req,out);
				break;
			case 20217:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				viewmarks.process_fdistribution(req,out);
				break;
			case 203:								
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/modifymarks.html");
				break;
			case 2031:												
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				process_modify_form(req,out);
				break;
			case 20311:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				 process_modify_marks(req,out);
				 break;
			case 301:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/entergrades.html");
				break;
			case 3011:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				process_gradeform(req,out);
				break;
			case 3012:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				process_enter_grades(req,out);
				break;
			case 302:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/modifygrades.html");
				break;
			case 3021:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				process_modify_grade_form(req,out);
				break;
			case 30211:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				process_modify_grades(req,out);
				break;
			case 303:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
				printpage(out,"/users/ug97/bhati/Proj/html/gradeview.html");
				break;
			case 3031:
				out.println("<html>course number selected is :"+cour.toString()+"<br>");
				out.println("semester number selected is :"+semes.toString()+"<br></html>");
			     process_bat(req,out);
				 break;
		}	
	}
	String marks_table;
	String quiz_number;
	int quiz_num;
	String cnum;
	String snum;
	int number_students=0;

//This the function which is used for generating the from for the insertion
//of marks for the quizzes.The corse number and the semnuber are read and the
//checks for the faculty whether he is actually taking the course
//And the information is correct i,e the table actually exists to enter the
//if yes then read the number of quizzes and print the form having that many
//number of fields,the roll number and the correspondin quiz marks ka field.
	public void process_stum(HttpServletRequest req, Statement stat1, PrintWriter out) 
		throws SQLException {
		try{			
			HttpSession hs=req.getSession(true);	
			cnum=(hs.getValue("course")).toString();
			snum=hs.getValue("sem").toString();
		//	cnum = (String)req.getParameter("cname");
		//	snum = (String)req.getParameter("snum");
			quiz_number = (String)req.getParameter("number");
			if(cnum.equals("")||snum.equals("")||quiz_number.equals(""))
			{
					out.println("Please fill all fields");
					return;
			}
			quiz_num=Integer.parseInt(quiz_number);
			ResultSet Rs = stat1.executeQuery("select fno from course_details_" +snum+
								" where cno='"+cnum+"'");
			if(Rs.next()){
				String check = Rs.getString("fno");
				
				if(check.equals(login)){
					ResultSet rs = stat1.executeQuery("select srollno from registered_for_"+snum +
						  " where cno='" + cnum+ "' order by srollno");
					if(rs.next()){

						int j=1;
						marks_table="M_"+snum+"_"+cnum;
						out.println("<html>");
						out.println("<h1>Entering marks of the whole batch</h1>");
						out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024/servlet/UdayServlet\" method=\"post\">");
						out.println("<input type=\"hidden\" name=\"formnum\" value=\"2012\">");
						out.println("<table border=3><td> S.no </td><td>Rollnum</td><td> Marks</td><tr>");
						do{
								number_students=j;
							  String Sroll = rs.getString("srollno");
								out.println("<td>"+j+"</td><td>"+ Sroll+"</td><td><input type=\"text\" size=4 maxlength=4 "+
										"  name=\"marks"+j+"\" ></td><tr>");
								j++;
						}while(rs.next());		
						out.println("<td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>");
						out.println("<td><input type=\"reset\" name=\"reset\" value=\"reset\"></td>");
						out.println("</table></form></body></html>");
					
					}
					else
					{
								out.println("No students registered for the course");
								return;
					}
				}
				else
				{
								out.println(" The faculty is not taking this course");
								return;
				}
			}
			else
			{
						out.println("Incorrect Information");
						return;
			}

		}catch(SQLException e){ out.println(e);}
	}
	//This function enter the marks filled in the above from no check has been done
//for the validity of the marks.This can be modified to vlidate the marks entered
//i,e for negative narks marks greater than the maxmarks etc.
//The marks are read and stored in an array.And then check whether the marks are 
//already entered. If so then prompt to the profy that they are already entered 
//so the marks are not entered.If the matks are not entered then enter the
//marks.
public void process_enter_marks(HttpServletRequest req,Statement stat1,PrintWriter out)
throws SQLException
{
	try{
	int i,j;
	float marks[] = new float[number_students];
	String markstr;
	con.setAutoCommit(false);
		for(i=0;i<number_students;i++)
		{
				markstr = (String)req.getParameter("marks"+(i+1));
				if(!markstr.equals("")){
				Float temp = new Float(markstr);
				marks[i]= temp.floatValue();
				}
				else 
						marks[i]=-1;
		}	
	  ResultSet rs = stat1.executeQuery("select srollno from registered_for_"+ snum+
		        " where cno='" + cnum+ "' order by srollno" );
		Statement stat2=con.createStatement();
		ResultSet rq1=stat2.executeQuery("select number_exams from course_details_"+snum+
									 " where cno='" + cnum + "'");
		rq1.next();
		int number_exams=rq1.getInt("number_exams");		
		Statement stat3 = con.createStatement();
		String rollnum[] = new String[number_students];
		for(i=0;i<number_students;i++)
		{	
				rs.next();
				
				String tmp = rs.getString("srollno");
				rollnum[i]=tmp;
				ResultSet Rs=stat3.executeQuery("select srollno from "+marks_table+ 
										" where srollno='"+ tmp + "'");
  			if(Rs.next())
				{
							Statement tempstat=con.createStatement();
							ResultSet tempset = tempstat.executeQuery("select  quiz_"+quiz_num +"  from     "+ 
						  	marks_table +" where srollno='"+tmp +"'");
							tempset.next();
							 float tempfloat = tempset.getFloat("quiz_"+quiz_num);
							 if(tempfloat!=-1)
							 {
							 		out.println("The marks are entered already");
									con.rollback();
									con.setAutoCommit(true);
									return;
							}
							 			
							stat3.executeUpdate(" update " + marks_table + " set quiz_"+quiz_num+
										"="+marks[i]+" where srollno='"+tmp +"'");
				}
				else 
				{
	  					String str="insert into " +marks_table + " values('"+tmp+"',";
		  				for(j=1;j<quiz_num;j++)
			  					str+="-1,";
							if(quiz_num<number_exams)
							{
				  	   str+=marks[i]+",";
					  	for(j=quiz_num+1;j <number_exams;j++)
						  		str+="-1,";
		  				  	str+="-1)";
								}
								else
										str+=marks[i]+")";
							Statement stat4 = con.createStatement();
							stat4.executeUpdate(str); 
							stat4.close();
							
		 		}
		}		
				out.println("<html>");
		out.println(" The Marks are entered<table border=3>");
		for(i=0;i<number_students;i++)
		{
				if(marks[i]!=-1)
				out.println("<td>"+rollnum[i]+"</td><td>"+marks[i]+"</td><tr>");
		}
				
		}catch(SQLException e){ out.println(e);} 
		con.commit();
		con.setAutoCommit(true);
		}

//This is the functio which is called for the viewing of the schema.
//The course name and the semno are read from the form and check if
//the table exist if it doesn't them prompt.Else read the schmea table
//the w_sem_sourse and print the sem number the maxmarks and the weigthage.

	public void process_view_schema(HttpServletRequest req,PrintWriter out)
		throws SQLException{
		HttpSession hs=req.getSession(true);	
		String cname=(hs.getValue("course")).toString();
		String snum=hs.getValue("sem").toString();
//		String 	cname = (String) req.getParameter("cname");
//		String 	snum = (String) req.getParameter("snum");
		if(cname.equals("")||snum.equals(""))
		{
			out.println("</html>All the fields are not filled</html>");
			return;
		}
		String weight_table = "w_"+snum+"_"+cname;
		Statement stat = con.createStatement();
		ResultSet Rs = stat.executeQuery("select table_name from tabs where table_name='"+weight_table.toUpperCase()+"'");
		if(Rs.next())
		{
		  	ResultSet Rs1 = stat.executeQuery("select * from "+weight_table);
			int j=1;
			out.println("<html><table border=3>");
			out.println(" <td>Quiz_no   </td> <td>Maxmarks </td>    <td>Weight</td><tr>");
			while(Rs1.next()){
				int quiz_no = Rs.getInt("quizno");
				int maxmarks = Rs.getInt("maxmarks");
				float weight = Rs.getFloat("weight");
				out.println("<td>"+quiz_no +"</td><td> "+ maxmarks+"</td><td> "+weight+"<tr>");
				}
				out.println("</table></body></html>");
		}
		else
			out.println("Schema not entered");

	}

  	String gra_sem;
	String gra_crs;
	int number_students_gra=0;
//This function is to enter the Grades of the batch it is similar to the
//marks enter but foor the table updated .the register fro table is updated.
// The form is generated reading the course and the sem and necessaery checks are
//made and then the form is generated which has all rollnum and the fields 
//for the grades.
	public void	process_gradeform(HttpServletRequest req,PrintWriter out)
		throws SQLException{
		try{
			Statement stat = con.createStatement();

			HttpSession hs=req.getSession(true);	
			gra_crs=hs.getValue("course").toString();
			gra_sem=hs.getValue("sem").toString();
		//	gra_crs=(String) req.getParameter("cnum");
		//	gra_sem=(String) req.getParameter("semno");
			if(gra_crs.equals("")||gra_sem.equals(""))
			{
					out.println("Please enter all fields");
					return;
			}
		  	ResultSet Rs = stat.executeQuery("select fno from course_details_" +gra_sem+
							" where cno='"+gra_crs+"'");
			if(Rs.next())
			{
				String check = Rs.getString("fno");
				if(check.equals(login)){
					ResultSet rs = stat.executeQuery("select srollno from registered_for_"+gra_sem+
			    	                 " where cno='" + gra_crs+ "'");
				    if(rs.next()){

						int j=1;
						out.println("<html>");
						out.println("<h1>Entering the Grade of the whole batch</h1>");
						out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024/servlet/UdayServlet\" method=\"post\">");
						out.println("<input type=\"hidden\" name=\"formnum\" value=\"3012\">");
						out.println("<table border=3><td> S.no</td><td> Rollnum </td>Grades</td><tr>");
						do{
								number_students_gra=j;
							  String Sroll = rs.getString("srollno");
								out.println("<td>"+j+"</td><td>"+ Sroll+"</td><td><input type=\"text\" size=4 maxlength=4 "+
										"  name=\"grade"+j+"\" ></td><tr>");
								j++;
						}while(rs.next());		
						out.println("</table><td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>");
						out.println("<td><input type=\"reset\" name=\"reset\" value=\"reset\"></td>");
						out.println("</form></body></html>");
					
					}
					else
					{
						out.println("No students registered for the course");
						return;
					}
				}
				else
				{
					out.println("The faculty is not taking this course");
					return;
				}
			}
			else
			{
				out.println("Incorrect Information");
				return;
			}

		}catch(SQLException e){ out.println(e);}
	}




//This function is to enter the grades filled in the form generated by the above
//function.This is similar to the marks entering.
public void process_enter_grades(HttpServletRequest req,PrintWriter out)
throws SQLException
{
	try{
	int i,j;
	String grade[] = new String[number_students_gra];
	con.setAutoCommit(false);
		for(i=0;i<number_students_gra;i++)
		{
				String temp_grade=(String)req.getParameter("grade"+(i+1));
				if(!(temp_grade.equals(""))){
							grade[i]=temp_grade;
				}
				else 
							grade[i]="null";
		}
		Statement stat1=con.createStatement();
		Statement stat2=con.createStatement();
	  ResultSet rs = stat1.executeQuery("select srollno,gradeval from registered_for_"+ gra_sem+
		        " where cno='" + gra_crs+ "'" );
		String rollnum[] = new String[number_students_gra];
		
		for(i=0;i<number_students_gra;i++)
		{	
				rs.next();
				
				String tmp = rs.getString("srollno");
				rollnum[i]=tmp;
				String temp_grade=rs.getString("gradeval");
			 if(temp_grade!=null)
			 {
					 		out.println("The grades are entered already ");
							con.rollback();
							con.setAutoCommit(true);
							return;
				}
							 			
							stat2.executeUpdate(" update  registered_for_"+gra_sem +" set"+
									" gradeval='"+grade[i]+"' where srollno='"+rollnum[i]+"'");
								
				}
				out.println("<html>");
		out.println(" Grades entered<table border=3>");
		for(i=0;i<number_students_gra;i++)
				out.println("<td>"+rollnum[i]+"</td><td>"+grade[i]+"</td><tr>");
		}catch(SQLException e){ out.println(e);} 
		con.commit();
		con.setAutoCommit(true);
		}

	int modify_marks_qnum;
	int modify_marks_students;
	String modify_marks_table;



	//This is to generate the form for the modification of the grades.
	//The form is almost same but for printing the default field as the
	//already entered marks.

	public void process_modify_form(HttpServletRequest req,PrintWriter out)
		throws SQLException{
		try{
			HttpSession hs=req.getSession(true);	
			String cnum=(hs.getValue("course")).toString();
			String semno=hs.getValue("sem").toString();
	//		String cnum=(String) req.getParameter("cnum");
	//		String semno=(String) req.getParameter("semno");
			String quiz_no=(String) req.getParameter("quiz_no");
			modify_marks_qnum = Integer.parseInt(quiz_no);
			int quiz_number = modify_marks_qnum;
			String marks_table = "m_"+semno+"_"+cnum;
			modify_marks_table = marks_table;
			if(cnum.equals("")||semno.equals("")||quiz_no.equals(""))
			{
						out.println("Please fill all fields");
						return;
			}
			Statement stat = con.createStatement();
			ResultSet temp = stat.executeQuery("select fno from course_details_"+semno+
				    " where cno='" + cnum+"'");
			if(temp.next()){
				String check = temp.getString("fno");
				if(check.equals(login)){
				ResultSet Rs = stat.executeQuery("select table_name from tabs"+
								" where table_name ='"+marks_table.toUpperCase()+"'");
					if(Rs.next()){
					
						ResultSet Rs1 = stat.executeQuery("select quiz_"+quiz_number+" from "
						+marks_table);
						
						if(Rs1.next()){
							ResultSet Rs2=stat.executeQuery("select srollno,quiz_"+quiz_number+
								" from "+marks_table);
														
							out.println("<html>");
							out.println("<h1>Modifying marks of the batch</h1>");
							out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024/servlet/UdayServlet\" method=\"post\">");
							out.println("<input type=\"hidden\" name=\"formnum\" value=\"20311\">");
							out.println("<table border=3><td> S.no</td> <td>Rollnum </td><td>Marks</td><tr>");
							int j=0;
							while(Rs2.next())
							{
									String rollnumber = Rs.getString("srollno");
									
									float marks = Rs.getFloat("quiz_"+quiz_number);
									if(marks!=-1)
									out.println("<td>"+j+"</td><td>"+rollnumber+"</td><td><input type=\"text\" name=\"marks"+(j+1)+"\" value=\""+marks+"\"></td><tr>");
									else								
									out.println("<td>"+j+"</td><td>"+rollnumber+"</td><td><input type=\"text\" name=\"marks"+(j+1)+
																	"\"></td><tr>");
									j++;
									
							}
							out.println("</table><td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>");
							out.println("<td><input type=\"reset\" name=\"reset\"  value=\"reset\"></td><tr>");
							out.println("</form></html>");
							modify_marks_students=j;
						}
						else
						{
								out.println("Incorrect Information");
								return;
						}
						
					}
				  	else
				
						 out.println("The marks table does not exists");
				}
				else
				{
					out.println("You are not registered for the Course");
					return;
				}
			}
			else
			{
				out.println("Information Incorrect");
				return;
			}
		}catch(SQLException e){out.println(e);}
	}


	//This is to modify marks is similar to the function enter marks but for
//giving a default field which has the already entered marks.

public void process_modify_marks(HttpServletRequest req,PrintWriter out)
throws SQLException
{
	try{
		int i;
		if(con==null)
			out.println("<html>can't connect to JDBC</html>");
		Statement stat = con.createStatement();
		
		ResultSet Rs = stat.executeQuery("select srollno,quiz_"+modify_marks_qnum+" from "+modify_marks_table);
		if(Rs==null)
			out.println("<html>incorrect information</html>");
		for(i=0;i<modify_marks_students;i++)
		{
				Rs.next();
				float mark;
			
				String marks = (String) req.getParameter("marks"+(i+1));
				Float temp = new Float(marks);
				mark = temp.floatValue();
				if(marks.equals(""))
						mark = -1;
				Statement stat2 = con.createStatement();
				stat2.executeUpdate("update "+modify_marks_table+" set quiz_"+modify_marks_qnum+"='"+mark+"' where srollno='"+Rs.getString("srollno")+"'");
 		}
		out.println("<html>marks modified</html>");
		}catch(SQLException e){out.println(e);}
		catch(NullPointerException e){out.println(e);}
	
 }
String modify_grade_table;
String modify_grade_course;
int modify_grade_students;



//This is the function to print the form for modifying the grades which are already
//entered. This is similar to the modify marks form.

	public void process_modify_grade_form(HttpServletRequest req,PrintWriter out)
		throws SQLException{
		try{
			HttpSession hs=req.getSession(true);	
			String cnum=(hs.getValue("course")).toString();
			String semno=hs.getValue("sem").toString();
		//	String cnum=(String) req.getParameter("cnum");
		//	String semno=(String) req.getParameter("semno");
			modify_grade_table="registered_for_"+semno;
			modify_grade_course=cnum;
			Statement stat = con.createStatement();
			ResultSet rs=stat.executeQuery(" select table_name from tabs where " +
				" table_name='" + modify_grade_table.toUpperCase()+"'");
			if(rs.next()){
				ResultSet temp = stat.executeQuery("select fno from course_details_"+semno+
					    " where cno='" + cnum+"'");
				if(temp.next()){
					String check = temp.getString("fno");
					if(check.equals(login)){
						ResultSet Rs1 = stat.executeQuery("select srollno,gradeval from "+modify_grade_table+
								" where cno='"+cnum+"'");
						if(Rs1.next()){
							
							out.println("<html>");
							out.println("<h1>Modifying grades of the batch</h1>");
							out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024/servlet/UdayServlet\" method=\"post\">");
							out.println("<input type=\"hidden\" name=\"formnum\" value=\"30211\">");
				//			out.println("<input type=\"hidden\" name=\"course\" value=\""+cnum+"\">");
							
							out.println("<table border=3> <td>S.no</td> <td>Rollnum </td><td>Grade</td><tr>");
							int j=0;
							do
							{
								String rollnumber = Rs1.getString("srollno");
								String Grade = Rs1.getString("gradeval");
								if(Grade!=null)
								out.println("<td>"+j+"</td><td>"+rollnumber+"</td><td><input type=\"hidden\" name=\"roll_"+(j+1)+"\" value=\""+rollnumber+"\"<td><input type=\"text\" name=\"grade_"+(j+1)+"\" value=\""+Grade+"\"></td><tr>");
								else								
								out.println("<td>"+j+"</td><td>"+rollnumber+"</td><td><input type=\"hidden\" name=\"roll_"+(j+1)+"\" value=\""+rollnumber+"\"<td><input type=\"text\" name=\"grade_"+(j+1)+"\"></td><tr>");
								j++;
								
							}while(Rs1.next());
							out.println("</table><td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>");
							out.println("<td><input type=\"reset\" name=\"reset\"  value=\"reset\"></td><tr>");
							out.println("</form></html>");
							modify_grade_students=j;

				
						}
						else
						{
							out.println("what BUH i can't see any students in the course");
							return;
						}
						
					}
					else
					{
						out.println("You are not taking the course BUH why are you here");
						return;
					}
				}
				else
				{
					out.println("I can't see this course at all in this sem");
					return;
				}
			}
			else
			{
				out.println("What BUH what have you typed");
				return;
			}
		}catch(SQLException e){out.println(e);}
	}
	
	public void process_modify_grades(HttpServletRequest req,PrintWriter out)
		throws SQLException{
	try{
		int i;
		Statement stat = con.createStatement();
		HttpSession hs=req.getSession(true);
		String str1=hs.getValue("course").toString();
//		String str1=(String) req.getParameter("course");
		out.println("<html>grades modified successfully</html>");
		ResultSet Rs = stat.executeQuery("select srollno,gradeval "+
		" from "+modify_grade_table+" where cno ='"+str1+"'");
		Statement stat2=con.createStatement();			   
		for(i=0;i<modify_grade_students;i++)
		{
				Rs.next();
				String Grade = (String) req.getParameter("grade_"+(i+1));
				if(Grade.equals(""))
						Grade="null";
				
				stat2.executeUpdate("update "+modify_grade_table+" set gradeval='"+Grade+"'"+
				" where srollno='"+Rs.getString("srollno")+"'");
 		}
		}catch(SQLException e){out.println(e);}
 }
 //This the function which prints the grades of the batch that is all the
 //studets who have taken the course.It prints all the grades stored in t he
 //registered_for table for that purticular semester.

	public void process_bat(HttpServletRequest req, PrintWriter out)
		throws SQLException{
		Statement stat2=con.createStatement();
		HttpSession hs=req.getSession(true);	
		String Cour=(hs.getValue("course")).toString();
		String semnum=hs.getValue("sem").toString();
	//	String Cour	 = (String)req.getParameter("cnum");
	//	String semnum = (String)req.getParameter("semno");
		if(Cour.equals("") || semnum.equals(""))
		{
				out.println("please fill all the fields");
				return;
		}
		String Cq2="select srollno, gradeval from registered_for_" +semnum+
		   " where cno = '" + Cour + "'" ;
		ResultSet rq2 = stat2.executeQuery(Cq2);
		if(!rq2.next())
		{
			out.println("The information is wrong");
			return;
		}
		else
		{
			out.println("RollNo.    Grade<br>");
			do{
				String s0 = rq2.getString("srollno");
				String s1 = rq2.getString("gradeval");
				out.println(s0 + "   " + s1 + "<br>");
			 }while(rq2.next());
		}
		out.println("</html>");
		stat2.close();
	}
}
