import java.util.*;
import java.util.Date;
import java.io.*;
import java.sql.*;
import java.lang.*;
import javax.servlet.http.*;

public class GrStudentSession extends GrSession{

	String login;
	
public GrStudentSession(Connection conn,String login){
			super(conn);
			login = login;
			}
public void printpage(PrintWriter out,String filename)
throws FileNotFoundException, IOException
{
		FileInputStream infile = new FileInputStream(filename);
		InputStreamReader reader = new InputStreamReader (infile);
		BufferedReader input = new BufferedReader (reader);
		String temp;
		
		while ( (temp = input.readLine())!=null)
					out.println(temp);
}
//This is the main fuction which is invoked when the user in the 
//Student area.The function reads the hidden field in the form and 
//calls the appropriate function.

	public void processQuery( HttpServletRequest req,PrintWriter out)
		throws SQLException,FileNotFoundException,IOException{

		String formnumber = (String)req.getParameter("formnum");
		Integer   temp = new Integer(formnumber);
		Statement stat1=con.createStatement();
		Date date = new Date();
		switch(temp.intValue())	{
			case 0:
				printpage(out,"/users/ug97/bhati/Proj/html/Student.html");
				break;
			case 1:
				HttpSession hs=req.getSession(true);
				String roll=hs.getValue("login_id").toString();
				
				int year = date.getYear()+1900;
				printpage(out,"/users/ug97/bhati/Proj/html/cpi.html");
				out.println("<td><input type=\"text\" name=\"rollnum\" value=\""+roll+"\"></td>");
				out.println("<tr><td>Enter Semester number</td><td><select name=\"sem\">"+
					"<option value=\"spr\">spr<option value=\"aut\">aut</select>"+
					"<td><input type=\"text\" name=\"year\" value=\""+year+"\"></td>"+
					"<tr><td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>"+
					"<td><input type=\"reset\" name=\"reset\" value=\"reset\"></td></table></form></html>");
				
				break;
			case 2:			
				hs=req.getSession(true);
				roll=hs.getValue("login_id").toString();
				
				year = date.getYear()+1900;
				printpage(out,"/users/ug97/bhati/Proj/html/mks.html");
				out.println("<td><input type=\"text\" name=\"rollnum\" value=\""+roll+"\"></td>");
				out.println("<tr><td>Enter Course Number</td><td><input type=\"text\" name=\"cnum\">");
				out.println("<tr><td>Enter Semester number</td><td><select name=\"sem\">"+
					"<option value=\"spr\">spr<option value=\"aut\">aut</select>"+
					"<td><input type=\"text\" name=\"year\" value=\""+year+"\"></td>"+
					"<tr><td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>"+
					"<td><input type=\"reset\" name=\"reset\" value=\"reset\"></td></table></form></html>");
				break;
			case 3 :
				printpage(out,"/users/ug97/bhati/Proj/html/bat.html");
				break;
			case 4:
				printpage(out,"/users/ug97/bhati/Proj/html/jun.html");
				break;
														
			case 101:
				process_cpi(req,  out);
				break;
			case 201 : 
				process_mks(req, out);
				break;
			case 301 : 
				process_bat(req, out);
				break;
			case 401:
				process_jun_marks(req,out);
				break;
		}


	}


	//This function is invoked when the user wants to see the performane 
	//of any student in a purticular sem.It reads the rollnumber and 
	//the semnum and in the sem_performance table the CPI and the Spi and 
	//in the registered for table for the grades in the courses he has 
	//registered.



	public void process_cpi(HttpServletRequest req, PrintWriter out)
		throws SQLException {
		Statement stat2=con.createStatement();
		String Sroll = (String)req.getParameter("rollnum");
		String semno = (String)req.getParameter("sem");
		String year = (String)req.getParameter("year");
		String Semno=semno+year;
		if(Sroll.equals("")||Semno.equals(""))	{
			out.println("Please fill all fields");
			return;
		}
		out.println("<html>");
		out.println("<table border=3>");
		ResultSet rq1= stat2.executeQuery("select cno,gradeval from " +
					" registered_for_"+Semno+" where srollno='"+Sroll+"'");
		if(rq1.next())	{	
			out.println("<td>Course</td><td>Grade</td><tr>");
			do{
				String course = rq1.getString("cno");
				String grade = rq1.getString("gradeval");
				out.println("<td>"+course+"</td><td>"+grade+"</td><tr>");
			}while(rq1.next());
		}
		String Cq="select cpi,spi from sem_performance" +
	        " where srollno = '" + Sroll + "' and semno = '" + Semno +"'";
		rq1 = stat2.executeQuery(Cq);
		if(rq1.next()) {
		 	float c1 = rq1.getFloat("cpi");
			out.println("<td>The Cpi is : " + c1+"</td><tr>");
			float s1 = rq1.getFloat("spi");
			out.println("<td>The Spi is : " + s1 +"</td><tr></table>");
		}
		else 
	 	out.println("Information Incorrect");
		stat2.close();
	}

//This function prints the marks obtained by a purticular student in a course
// it reads the weightages and max marks from the weight_table and then
//marks from the marks table coorespoding to that course and then 
//calculates the percentage of marks obtained. If there are null entries in the
//marks table it ignores them and calculates the percentage on  the remaining 
//marks only.

	public void process_mks(HttpServletRequest req, PrintWriter out)
		throws SQLException	{
		int number_exams=0;
		Statement stat2=con.createStatement();
		Statement stat1=con.createStatement();
		String Sroll1 = (String)req.getParameter("rollnum");
		String Cour	 = (String)req.getParameter("cnum");
		String semno = (String)req.getParameter("sem");
		String year = (String)req.getParameter("year");
		String semnum=semno+year;
		if(Sroll1.equals("")|| Cour.equals("")||semnum.equals(""))
		{
				out.println("Please fill all fields");
				return;
		}
		String tabname = "m_"+semnum+"_"+Cour;
	//Does the table exists at all?????????
	  	ResultSet Rs1 = stat1.executeQuery("select table_name from tabs "+
					" where table_name='"+tabname.toUpperCase()+"'");
		if(Rs1.next()){
			out.print("<html><table border=3> ");
			String wname = "w_";
			wname = wname.concat(semnum);
			wname = wname.concat("_" + Cour);
		 
			Statement new_1 = con.createStatement();

		//if profy allowing junta to view the marks.Check the flag and 
		//If allowing then carry on else give the appropriate message.
		//change
			ResultSet news_1 = new_1.executeQuery("select flag from "+wname );
			news_1.next();
			int flag = news_1.getInt("flag");
			
			if(flag==1){
				out.println("Information made inaccessible by Professor");
				return;
			}
			if((flag==2) && !(Sroll1.equals(login)))
			{
				out.println("Access Forbidden");
				return;
			}
			Statement stat3=con.createStatement();
			ResultSet Rs=stat3.executeQuery("select number_exams from course_details_"+semnum+
										" where cno='"+Cour+"'");
			Rs.next();
			number_exams = Rs.getInt("number_exams");
			
			String Cq2="select * from " + tabname +
	  			 " where srollno = '" + Sroll1 + "'" ;
			 ResultSet rq2 = stat2.executeQuery(Cq2);
			 float ma[] = new float[100];
			 int  j;
			 String tmp1, rtmp;
			 if(!rq2.next())
			 {
					out.println("Incorrect Information :"+ tabname);
					return;
			}
							
			 do{
				 try{
					 rtmp = rq2.getString("srollno");
										 
					 for (j=0; j<number_exams; j++) {
					 	 tmp1 = "quiz_" + (j+1);
						 ma[j] = rq2.getFloat(tmp1);
					 }	
				 }catch(SQLException e){out.println(e);}
			 }while(rq2.next());

			 out.println("<td> quizno</td><td> marks</td> <td>maxmarks </td><td>weightage </td><tr>");
//This routine is used for calculating the total percentage of the 
//marks obtained till now by calculating the the marks
//marks/maxmarks * weightage gives the partial marks of this quiz.
//add this over all the quizzes.
									
			String Cq3="select * from " + wname ;
		 	float w, to;
			try{ Statement stament=con.createStatement();
				ResultSet rq3 = stament.executeQuery(Cq3);
				int mm;
				to = 0;
				float temp_weight=0;
				for(j=0;j<number_exams;j++){
					if(rq3.next()) {
				 		mm = rq3.getInt("maxmarks");
				 		w = rq3.getFloat("weight");
				 		if(ma[j]!=-1){
				    			to = to + ((ma[j]*w)/(mm));
							temp_weight+=w;
							out.println(" <td> "+(j+1)+"</td><td> " + ma[j] +"</td><td> " + mm +"</td><td>"+w +"</td><tr>");
						}
			 		}
					else{
						break;
					}
				}		
				if(temp_weight!=0)
				 out.println("</table>The percentage of marks so far is " + to*100/temp_weight + "%<tr>");
				else
				 out.println("The percentage of marks so far is  0 %<tr>");

			 }catch(SQLException e){ out.println(e);}
		}
		else
			out.println("NO marks entered so far");
		stat2.close();
						
}


//The function is invoked for viewing the grades of the batch in a purticular
//course.This function reads the course number and the semnumber and then 
// looks up the grades of all the students registered for that vourse in the
//register_for table for that semester and prints them.
	public void process_bat(HttpServletRequest req, PrintWriter out)
		throws SQLException{
		Statement stat2=con.createStatement();
		String Cour = (String)req.getParameter("cnum");
		String semno = (String)req.getParameter("sem");
		String year=(String)req.getParameter("year");
		String semnum= semno+year;
		if(Cour.equals("") || semnum.equals("")){
			out.println("Please fill all fields");
			return;
		}
		String Cq2="select srollno, gradeval from registered_for_" +semnum+
   			" where cno = '" + Cour + "'" ;
		ResultSet rq2 = stat2.executeQuery(Cq2);
		if(!rq2.next()){
			out.println("Incorrect Information");
			return;
		}
		else{
			 out.println("<html>Sem Number: " + semnum + "<br>");
			 out.println("Course Number: " + Cour + "<br> "+ " " + " <br> ");
			 out.println("RollNo.    Grade<br>");
			 do{
				String s0 = rq2.getString("srollno");
				String s1 = rq2.getString("gradeval");
				out.println(s0 + "   " + s1 + "<br>");
			  }while(rq2.next());
		}
		out.println("</html>");
		stat2.close();
	}

//This function is invoked when the user wants to see the marks of the 
//batch(Actually he can see the marks of the batch even he is not registered
//for the course).We felt this is o.k because making marks accessable to only
//to the students registered for the course does'nt seem very necessary


//The function reads the Course number and the semnum and the quiz_number of
//which the student wants to see the marks  and then checks in the schema
//table whether the profy wants to make this quiz viewable if not then 
// ditch if they are viewable then print marks of all the students 
// in that quiz in the ascending order.

	public void process_jun_marks(HttpServletRequest req,PrintWriter out)
		throws SQLException{
		try{
			int MAX=100;
			Statement stat1 = con.createStatement();
			String Cour	 = (String)req.getParameter("cnum");
			String semno = (String)req.getParameter("sem");
			String year = (String)req.getParameter("year");
			String semnum=semno+year;
			String quiz_number = (String)req.getParameter("quiz_number");
			int quiz_num = Integer.parseInt(quiz_number);
			if(Cour.equals("") || semnum.equals(""))
			{
						out.println("Please fill all fields");
						return;
			}
			ResultSet Rs=stat1.executeQuery("select srollno,quiz_"+quiz_num+
					" from m_"+semnum+"_"+Cour+" order by quiz_"+quiz_num);
			
			

				
										
			if(Rs.next())
			{
				Statement stat2=con.createStatement();
				ResultSet Rs1=stat2.executeQuery("select flag from w_"+semnum+"_"+Cour);

				Rs1.next();
				int flag=Rs1.getInt("flag");
				if(flag!=3){
						out.println("Information made inaccessible by Professor");
						return;
				}
				out.println("<html>");
				out.println("<table border=3>");
				out.println("<td>Sno</td><td>Rollnum</td><td>Marks</td><tr>");
				float temp;
				int i,j=0,k=0;
				String temp_str;
				float marks[] = new float[MAX];
				String  Roll[] = new String[MAX];
				do
				{
					temp_str=Rs.getString("srollno");			
					temp=Rs.getFloat("quiz_"+quiz_num);
					if(temp!=-1)
					{
							Roll[j]=temp_str;
							marks[j]=temp;
							j++;
					}
				}while(Rs.next());
				for(i=0;i<j;i++)
					out.println("<td>"+(i+1)+"</td><td>"+Roll[i]+"</td><td>"+marks[i]+"<tr>");
				out.println("The remaining students marks have not been entered<tr>");
				out.println("</table></body></html>");
				
			}	
			else
				out.println("No marks entered so far");
		}catch(SQLException	e){out.println(e);}				
	}
	
}
