// this file contains the class that does all the processing related to 
// the queries of Marks in the faculty page. 

import java.lang.*;
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.servlet.http.*;

public class ProfView{
	String login;
	String marks_table;
	String  weight_table;
	int number_marks, rangenum;
	String cnum;
	String snum;


	Connection con;
	public ProfView(String login_id,Connection conn){
		login = new String(login_id);
		con=conn;
	}
// This function deals with the option of Viewing Marks of a students in 
// course ... The other forms in succesive links are generated thru this 
// function. There are some global variables defined to be used in 
// successive forms like number_marks, cnum, snum.

public void process_viewm(HttpServletRequest req, Statement stat1,PrintWriter out) 
		throws SQLException {
		try{	HttpSession hs=req.getSession(true);
			
			cnum = hs.getValue("course").toString();
			snum = hs.getValue("sem").toString();

	// If the fields are not filled fully then .... 

			if(cnum.equals("")||snum.equals(""))
			{
					out.println("Please fill all fields");
					return;
			}

	// To take the fno and number_exams from the course_details_<semno> so that
	// the Prof. can be authenticated to move further.

			ResultSet Rs = stat1.executeQuery("select fno, number_exams From course_details_" +snum+
										" where cno='"+cnum+"'");
			if(Rs.next())
			{
				String check = Rs.getString("fno");

// The login which is the fno is checked with fno for the course.
		
				if(check.equals(login)){
					int ne = Rs.getInt("number_exams");
				
// The global variable is assigned ..
				
					number_marks=ne;
					out.println("<html>");
					Banner.getBanner();
					out.println("<table><tr><td>Rollno.</td>");
					String ne1;
					int n1;
					for (n1=1; n1 <= ne; n1++) {
						ne1="quiz_"+n1;
						out.println("<td>"+ ne1 + "</td>");
					}
					out.println("<td>Total</td>");
					out.println("<tr>");
					String rono;
					int mat;
					float intot;
					float avg[] = new float [ne+1];
					int jk=1;
					float wt[] = new float [ne+1];
					int mm[] = new int [ne+1];
					int tot = 0;
					for (n1 = 0; n1 <= ne; n1++) {
						avg[n1] = 0;
					}
	//The global vars for table names are made ...
					
					weight_table ="w_"+snum+"_"+cnum;
					marks_table = "m_"+snum+"_"+cnum;
					
	// The query to extract marks from the w_<semno>_<cno>

					ResultSet rsw = stat1.executeQuery("select * from w_"+snum+"_"+cnum);
					while (rsw.next()) {
						mm[jk] = rsw.getInt("maxmarks");
						wt[jk] = rsw.getFloat("weight");
						jk++;
					}
					ResultSet rs = stat1.executeQuery("select * from m_"+snum+"_"+cnum+
					" order by srollno");
					
	// To extract the fields and print it. Calculates the Total of every student 
	// and average of every quiz and prints it accordingly.
					
					while (rs.next()) {
						tot++;
						rono = rs.getString("srollno");
						out.println("<td>" + rono + "</td> ");
						intot = 0;
						for (n1=1; n1 <= ne; n1++) {
							ne1="quiz_"+n1;
							mat = rs.getInt(ne1);
							if (mat==-1){ 
								out.println(" <td>"+"    "+"</td>  ");
							}
							else {
								avg[n1]=avg[n1]+mat;
								intot = intot + (mat*wt[n1])/mm[n1];
								out.println("<td>"+ mat + " </td> ");	
							}
						}
						out.println("<td>"+intot+"</td><tr>");
					}
					out.println("<tr><td>average</td>");
					intot = 0;
					for (n1=1; n1<=ne; n1++){
						avg[n1]=avg[n1]/tot;
						intot = intot + (avg[n1]*wt[n1])/mm[n1];
						out.println("<td>"+avg[n1]+"</td>");
					}
					out.println("<td>"+intot+"</td>");
					out.println("</table>");

	// The following are the three more options given in the page for the 
	// marks query. namely to 
	// 1. sort according to some specific quiz fields. 
	// 2. see the students in a given range of total
	// 3. view the distribution.

					String t11="<form action=\"http://everest.cse.iitb.ernet.in:5024"+
					"/servlet/UdayServlet\" method=post><input type=\"hidden\" name=\"formnum\"" +
					" value=\"20211\"><input type=\"submit\" name=\"submit\" value=" +
					"\"View sorted marks according to total of selected exams\">"+
					" </form><br>";
					out.println(t11);
				

					String t12="<form action=\"http://everest.cse.iitb.ernet.in:5024"+
					"/servlet/UdayServlet\" method=post><input type=\"hidden\" name=\"formnum\"" +
					" value=\"20212\"><input type=\"submit\" name=\"submit\" value=" +
					"\"View students in given range of marks\">"+
					" </form><br>";
					out.println(t12);
					
					String t13="<form action=\"http://everest.cse.iitb.ernet.in:5024"+
					"/servlet/UdayServlet\" method=post><input type=\"hidden\" name=\"formnum\"" +
					" value=\"20213\"><input type=\"submit\" name=\"submit\" value=" +
					"\"View the Distribution\">"+
					" </form><br>";
					out.println(t13);
					
					out.println("</table></body></html>");
				}

	// if the faculty is not taking the course..

				else
				{
					out.println(" The faculty is not taking this course");
					return;
				}
			}
			else
			{
						out.println("Incorrect Information");
						return;
			}

		}catch(SQLException e){ out.println(e);}
	}

	// The following function takes a range and prints the students whose marks are
// in that range

public  void process_range(HttpServletRequest req,PrintWriter out)
throws SQLException
{
int i;
out.println("<html>");
Banner.getBanner();
out.println("<h1> Enter the two end vlaues <h1>");
								
out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024"+
				"/servlet/UdayServlet\" method=post><input type=\"hidden\" name=\"formnum\"" +
				" value=\"20215\"><table>");

out.println("<tr><td>First Point</td><td><input type=\"text\" name=\"fir\"></td>");
out.println("<td>Second Point</td><td><input type=\"text\" name=\"sec\"></td>");
out.println("<tr><td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>");
out.println("<td><input type=\"reset\" name=\"reset\" value=\"reset\"></td>");


out.println("</table></body></html>");
}


public void process_frange(HttpServletRequest req,  PrintWriter out) 
throws SQLException {
		try{		
			Statement stat1 = con.createStatement();
			int n1;
			float lower, upper, temp, mat;
			int ne = number_marks;
			float wt[] = new float [ne+1];
			int mm[] = new int [ne+1];
			float intot = 0;
			
			int jk=1;	
			ResultSet rsw = stat1.executeQuery("select maxmarks, weight from "+weight_table);
			while (rsw.next()) {
				mm[jk] = rsw.getInt("maxmarks");
				wt[jk] = rsw.getFloat("weight");
				jk++;
			}
			
			String t, ne1, rono;
			String t1 = req.getParameter("fir");
			Float te1 = new Float (t1);
			lower = te1.floatValue();
			t1 = req.getParameter("sec");
			Float te2 = new Float (t1);
			upper = te2.floatValue();
			if (lower>upper) {
				temp = lower; 
				lower = upper;
				upper = temp;
			}
			
			out.println("<html>");
			Banner.getBanner();
			out.println("<table><tr><td>Rollno.</td>");
			
			t1 = "select srollno, ";
			t = " ";
			
			for (n1=1; n1 <= number_marks; n1++) {
				ne1="quiz_"+n1;
				t1 = t1 + ne1 + ", ";
				t = t + " (sign(" + ne1 + "+1)*quiz_"+n1+"*"+wt[n1]+"/"+mm[n1]+") +";
				out.println("<td>"+ ne1 + "</td>");
			}
			
			out.println("<td>Total</td>");
			out.println("<tr>");
			int len=t.length();
			t = t.substring(1,len-1);
			String t2 = t + " as total ";
			t1 = t1 + t2 + "  from " + marks_table + " where " + t + " <= "+upper+" and " + t + " >= "+
			lower+" order by total desc";

			ResultSet rs = stat1.executeQuery(t1);
				
			while (rs.next()) {
				intot = 0;
				rono = rs.getString("srollno");
				out.println("<td>" + rono + "</td> ");
				for (n1=1; n1 <= ne; n1++) {
					ne1="quiz_"+n1;
					mat = rs.getFloat(ne1);
					if (mat==-1) 
						out.println(" <td></td>  ");
					else {
						out.println("<td>"+ mat + " </td> ");	
					}
				}
				intot = rs.getFloat("total");
				out.println("<td>"+intot+"</td><tr>");
			}
			out.println("</table></body></html>");
		}catch(SQLException e){ out.println(e);} 
		}
			


public  void process_distribution(HttpServletRequest req,PrintWriter out)
throws SQLException
{
int i;
out.println("<html><body>");
Banner.getBanner();
out.println("<h1>  View the Distribution <h1>");
							
out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024"+
				"/servlet/UdayServlet\" method=post><input type=\"hidden\" name=\"formnum\"" +
				" value=\"20216\"><table>");

out.println("<td>Enter no. of Parts</td><td><input type=\"text\" name=\"part\"></td>");
out.println("<tr><td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>");
out.println("<td><input type=\"reset\" name=\"reset\" value=\"reset\"></td>");


out.println("</table></form></body></html>");
}

/*
public  void process_distribution1(HttpServletRequest req,PrintWriter out)
	throws SQLException{
	int i;
	out.println("<html><body>");
	Banner.getBanner();

	HttpSession hs = req.getSession(true);
	String str_brk_pts = new String(req.getParameter("part"));
	//Integer te1 = new Integer(rangenum);
	hs.putValue("str_brk_pts",str_brk_pts);
	int t_brk_pts = Integer.parseInt(str_brk_pts);
	int num_brk_pts = t_brk_pts +1;


	out.println("<h1> view the " + num_brk_pts + " Points of the range <h1>");
	for ( i = 0; i <= (num_brk_pts-1); i++)
	{
		out.println("<tr><td>Point " + i + " : " + 100*i/(num_brk_pts-1) +"</td><br>");
	}
									
	out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024"+
					"/servlet/UdayServlet\" method=post><input type=\"hidden\" name=\"formnum\"" +
					" value=\"20217\"><table>");

	out.println("<input type=\"submit\" name=\"submit\" value=\"submit\">");

	out.println("</table></form></body></html>");
}*/
/* -----the below function is a doubtful starter
public void process_distribution2(HttpServletRequest req, PrintWriter out)
	throws SQLException {
		try{
			String decision = (String)req.getParameter("decide");
			if (decision == "ok"){
				out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024"+
				"/servlet/UdayServlet\" method=post><input type=\"hidden\" name=\"formnum\"" +
				" value=\"20217\"><table>");
			}
			else if (decision == "change distribution"){
				out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024"+
				"/servlet/UdayServlet\" method=post><input type=\"hidden\" name=\"formnum\"" +
				" value=\"20216\"><table>");
			}
		}catch (SQLException e);
	}
			
-----------------------------------------------*/
public void process_fdistribution(HttpServletRequest req,  PrintWriter out) 
throws SQLException {
		try{	
			Statement stat1 = con.createStatement();
			int n1,s1,s2;
			float temp, mat;
			int ne = number_marks;
			float wt[] = new float [ne+1];
			int mm[] = new int [ne+1];
			float intot = 0;
			
			
			HttpSession hs = req.getSession(true);
			String str_brk_pts=new String((hs.getValue("str_brk_pts")).toString());
		     int t_brk_pts = Integer.parseInt(str_brk_pts);
			int num_brk_pts = t_brk_pts;
			rangenum=num_brk_pts-1;

			float rangearr[] = new float [rangenum+3];
			int jk=1;	
			ResultSet rsw = stat1.executeQuery("select maxmarks, weight from "+weight_table);
			while (rsw.next()) {
				mm[jk] = rsw.getInt("maxmarks");
				wt[jk] = rsw.getFloat("weight");
				jk++;
			}
			int s3;
			String t, ne1, rono;
			for (s1=0; s1<=rangenum+2; s1++) {
				rangearr[s1] = 0;
			}
			float p[]=new float[rangenum+2];
			for(s1=0;s1<=rangenum+1;s1++){
				p[s1]=100*(s1)/(rangenum+1);
			}
			for (s1=1; s1<=rangenum+1; s1++) 
			{
				//String t1 = req.getParameter("p_"+s1);
				//Float te1 = new Float (t1);
				//temp = te1.floatValue();
				temp = p[s1];
			//	System.out.println(temp);
				s2 = 1;
				while (rangearr[s2] > temp) {
					s2++;
				}
		//		System.out.println("s2 = " + s2);
				s3=s1; 
				while (s3 >=s2)  
				{
					rangearr[s3+1] = rangearr[s3];
					s3 = s3 - 1;
				}
		//		System.out.println("S3 = " + s3);
				rangearr[s3+1] = temp;
			}
			for (s3 = 0; s3 <= rangenum+1; s3++) {
	//			System.out.println(rangearr[s3]);
			}
			out.println("<html>");
			
			Banner.getBanner();
			out.println("<table><tr><td>Rollno.</td>");
			String t1;	
			t1 = "select srollno, ";
			t = " ";
			
			for (n1=1; n1 <= number_marks; n1++) {
				ne1="quiz_"+n1;
				t1 = t1 + ne1 + ", ";
				t = t + " (sign(" + ne1 + "+1)*quiz_"+n1+"*"+wt[n1]+"/"+mm[n1]+") +";
				out.println("<td>"+ ne1 + "</td>");
			}
			
			out.println("<td>Total</td>");
	//		out.println("<tr>");
			int len=t.length();
			t = t.substring(1,len-1);
			String t2 = t + " as total ";
			String tt;
			for (s1=1; s1 <= rangenum+1; s1++){
// Print Line Here					
 
				tt = t1 + t2 + "  from " + marks_table + " where " + t + " <= "+
				rangearr[s1]+" and " + t + " >= "+ rangearr[s1+1] + " order by total desc";
				ResultSet rs = stat1.executeQuery(tt);
				if(rs.next())
					out.println("<tr><td><br></td><td><br></td><td><hr></td><td>range </td><td>is</td><td> "+rangearr[s1+1]+"</td><td>to</td><td>"+rangearr[s1]+"</td>");
				tt = t1 + t2 + "  from " + marks_table + " where " + t + " <= "+
					rangearr[s1]+" and " + t + " >= "+ rangearr[s1+1] + " order by total desc";
				rs = stat1.executeQuery(tt);
				while(rs.next()) {
					intot = 0;
					rono = rs.getString("srollno");
					out.println("<tr><td>" + rono + "</td> ");
					for (n1=1; n1 <= ne; n1++) {
						ne1="quiz_"+n1;
						mat = rs.getFloat(ne1);
						if (mat==-1) 
							out.println(" <td>    </td>  ");
						else {
							out.println("<td>"+ mat + " </td> ");	
						}
					}
					intot = rs.getFloat("total");
					out.println("<td>"+intot+"</td>");
				}
			}

			
			out.println("</table></body></html>");
		}catch(SQLException e){ out.println(e);} 
		}


public  void process_sortform(HttpServletRequest req,PrintWriter out)
throws SQLException
{
int i;
out.println("<html><body>");
Banner.getBanner();
out.println("<h1> Select the exams for which you want to view the cumulative performance.<h1>");
							
out.println("<form action=\"http://everest.cse.iitb.ernet.in:5024"+
				"/servlet/UdayServlet\" method=post><input type=\"hidden\" name=\"formnum\"" +
				" value=\"20214\"><table>");
for(i=1;i<=number_marks;i++)
			out.println("<td><input type=checkbox name=\"quiz_"+i+"\""+"></td><td>Quiz_"+i+"</td><tr>");
out.println("<td><input type=\"submit\" name=\"submit\" value=\"submit\"></td>");
out.println("<td><input type=\"reset\" name=\"reset\" value=\"reset\"></td>");
out.println("</table></form></body></html>");
}


// assuming snum, cnum, ne already there as globals

public void process_fsort(HttpServletRequest req,  PrintWriter out) 
throws SQLException {
		try{		
			Statement stat1 = con.createStatement();
			
			int flarr[] = new int [number_marks+1];
			int f=0;

			for (f = 1; f <= number_marks; f++){
				String gun = req.getParameter("quiz_"+f);
				if (gun != null) {
					if (gun.compareTo("on") == 0)
						flarr[f] = 1;
					else 
						flarr[f] = 0;
				}
				else 
					flarr[f] = 0;
			}
			
		
			out.println("<html>");
			Banner.getBanner();
			out.println("<table border=3><tr><td>Rollno.</td>");
			String ne1;
			int n1;
			int ne=number_marks;
			String q,t;
			String rono;
			float mat;
			float intot;
			float avg[] = new float [ne+1];
			int jk=1;
			float wt[] = new float [ne+1];
			int mm[] = new int [ne+1];
			int tot = 0;
			for (n1 = 0; n1 <= ne; n1++) {
				avg[n1] = 0;
			}
			ResultSet rsw = stat1.executeQuery("select maxmarks, weight from "+weight_table);
			while (rsw.next()) {
				mm[jk] = rsw.getInt("maxmarks");
				wt[jk] = rsw.getFloat("weight");
				jk++;
			}
			q = "select srollno, ";
			t = "";
			for (n1=1; n1 <= number_marks; n1++) {
				if (flarr[n1] == 1) {
					ne1="quiz_"+n1;
					q = q + ne1 + ", ";
					t = t + " (sign(" + ne1 + "+1)*quiz_"+n1+"*"+wt[n1]+"/"+mm[n1]+") +";
					out.println("<td>"+ ne1 + "</td>");
				}
			}
			out.println("<td>Total</td>");
			out.println("<tr>");
			int len=t.length();
			t = t.substring(1,len-1);
			t = t + " as total";
			q = q + t + " from " + marks_table + " order by total desc";
			
			ResultSet rs = stat1.executeQuery(q);
				
			while (rs.next()) {
				tot++;
				rono = rs.getString("srollno");
				out.println("<td>" + rono + "</td> ");
				for (n1=1; n1 <= ne; n1++) {
					if (flarr[n1] == 1) {
						ne1="quiz_"+n1;
						mat = rs.getFloat(ne1);
						if (mat==-1) 
							out.println(" <td></td>  ");
						else {
							avg[n1]=avg[n1]+mat;
							out.println("<td>"+ mat + " </td> ");	
						}
					}
				}
				intot = rs.getFloat("total");
				out.println("<td>"+intot+"</td><tr>");
			}
			out.println("<tr><td>average</td>");
			intot = 0;
			for (n1=1; n1<=ne; n1++){
				if (flarr[n1] == 1) 
				{
					avg[n1]=avg[n1]/tot;
					intot = intot + (avg[n1]*wt[n1])/mm[n1];
					out.println("<td>"+avg[n1]+"</td>");
				}
			}
			out.println("<td>"+intot+"</td>");
			
			out.println("</table></body></html>");
		}catch(SQLException e){ out.println(e);} 
		}
	}









